#!/bin/bash
date='date +%Y-%m-%d\ %T'
logfile=~/.wkgen.log
prepath="${XDG_PICTURES_DIR:=$HOME/Pictures}"
mkdir -p "$prepath/wallpaper"
filelocation="$prepath/wallpaper/wk-progress.1.png"
set -e
oldhash="$(sha256sum $filelocation || echo none)"
echo "[$(eval $date)]: starting webrequests..." | tee -a $logfile
curl -s -o $filelocation -A "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36" -o "wallpaper.png" "http://wkw.natural20design.com/?k=7b98a684-5c91-44ab-86b1-f7023609fe4e&d=1"
newhash="$(sha256sum $filelocation)"
echo -e "\tnew:\t$newhash\n\told:\t$oldhash"
if [[ "$oldhash" = "$newhash" ]]; then
    echo "same files, nothing to do"
    exit
else
    echo "[$(eval $date)]: setting wallpaper..." | tee -a $logfile
	gsettings set org.gnome.desktop.background picture-uri file://${filelocation}
	gsettings set org.gnome.desktop.background picture-uri-dark file://${filelocation}
	gsettings set org.gnome.desktop.background picture-options 'stretched'
    echo "[$(eval $date)]: done" | tee -a $logfile
fi
